﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Media.Media3D;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SpeedTest
{
    using System.Collections.ObjectModel;
    using System.IO;
    using System.Runtime.Serialization;
    using System.Xml;

    using Infragistics.Controls.Charts;

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Point3D[]? data;

        private TriangulationSource triangulationSource;

        public MainWindow()
        {
            InitializeComponent();

            Stream stream = null;
            XmlReader reader = null;

            try
            {
                stream = new FileStream("Points.xml", FileMode.Open, FileAccess.Read);
                reader = XmlReader.Create(stream);

                DataContractSerializer serializer = new DataContractSerializer(typeof(Point3D[]));
                data = (Point3D[])serializer.ReadObject(reader);
            }
            catch (Exception ex)
            {
            }

            this.xAxis1.MinimumValue = this.data.Min(point3D => point3D.X);
            this.xAxis1.MaximumValue = this.data.Max(point3D => point3D.X);
            this.yAxis1.MinimumValue = this.data.Min(point3D => point3D.Y);
            this.yAxis1.MaximumValue = this.data.Max(point3D => point3D.Y);

            this.xAxis2.MinimumValue = this.data.Min(point3D => point3D.X);
            this.xAxis2.MaximumValue = this.data.Max(point3D => point3D.X);
            this.yAxis2.MinimumValue = this.data.Min(point3D => point3D.Y);
            this.yAxis2.MaximumValue = this.data.Max(point3D => point3D.Y);

            //not sure how to set it up.
            triangulationSource = TriangulationSource.Create(this.data.Length, this.GetXy, this.GetValue);

        }

        private float GetValue(int arg)
        {
            return (float)this.data[arg].Z;
        }

        private Point GetXy(int arg)
        {
            return new Point(this.data[arg].X, this.data[arg].Y);
        }

        private void ButtonBase_OnClick(object sender, RoutedEventArgs e)
        {            
            this.chartDoesTriangulationSeries.ItemsSource = this.data;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            preTriangulatedSeries.ItemsSource = triangulationSource.Points;
            preTriangulatedSeries.TrianglesSource = triangulationSource.Triangles;
        }
    }
}